QwtGraphic(3)

NAME
QwtGraphic - A paint device for scalable graphics.

SYNOPSIS

#include <qwt_graphic.h>

Inherits QwtNullPaintDevice.

  Public Types
enum RenderHint { RenderPensUnscaled = 0x1 }
enum CommandType { VectorData = 1 << 0, RasterData = 1 << 1, Transformation = 1 << 2 }
typedef QFlags< RenderHint > RenderHints
typedef QFlags< CommandType > CommandTypes

  Public Member Functions
QwtGraphic ()
Constructor.
QwtGraphic (const QwtGraphic &)
Copy constructor.
virtual ~QwtGraphic ()
Destructor.
QwtGraphic & operator= (const QwtGraphic &)
Assignment operator.
void reset ()
Clear all stored commands.
bool isNull () const
bool isEmpty () const
CommandTypes commandTypes () const
void render (QPainter *) const
Replay all recorded painter commands.
void render (QPainter *, const QSizeF &, Qt::AspectRatioMode=Qt::IgnoreAspectRatio) const
Replay all recorded painter commands.
void render (QPainter *, const QPointF &, Qt::Alignment=Qt::AlignTop|Qt::AlignLeft) const
Replay all recorded painter commands.
void render (QPainter *, const QRectF &, Qt::AspectRatioMode=Qt::IgnoreAspectRatio) const
Replay all recorded painter commands.
QPixmap toPixmap (qreal devicePixelRatio=0.0) const
Convert the graphic to a QPixmap.
QPixmap toPixmap (const QSize &, Qt::AspectRatioMode=Qt::IgnoreAspectRatio, qreal devicePixelRatio=0.0) const
Convert the graphic to a QPixmap.
QImage toImage (qreal devicePixelRatio=0.0) const
Convert the graphic to a QImage.
QImage toImage (const QSize &, Qt::AspectRatioMode=Qt::IgnoreAspectRatio, qreal devicePixelRatio=0.0) const
Convert the graphic to a QImage.
QRectF scaledBoundingRect (qreal sx, qreal sy) const
Calculate the target rectangle for scaling the graphic.
QRectF boundingRect () const
QRectF controlPointRect () const
const QVector< QwtPainterCommand > & commands () const
void setCommands (const QVector< QwtPainterCommand > &)
Append paint commands.
void setDefaultSize (const QSizeF &)
Set a default size.
QSizeF defaultSize () const
Default size.
qreal heightForWidth (qreal width) const
qreal widthForHeight (qreal height) const
void setRenderHint (RenderHint, bool on=true)
bool testRenderHint (RenderHint) const
RenderHints renderHints () const

  Protected Member Functions
virtual QSize sizeMetrics () const override
virtual void drawPath (const QPainterPath &) override
virtual void drawPixmap (const QRectF &, const QPixmap &, const QRectF &) override
Store a pixmap command in the command list.
virtual void drawImage (const QRectF &, const QImage &, const QRectF &, Qt::ImageConversionFlags) override
Store a image command in the command list.
virtual void updateState (const QPaintEngineState &) override
Store a state command in the command list.

Detailed Description

A paint device for scalable graphics. QwtGraphic is the representation of a graphic that is tailored for scalability. Like QPicture it will be initialized by QPainter operations and can be replayed later to any target paint device.

While the usual image representations QImage and QPixmap are not scalable Qt offers two paint devices, that might be candidates for representing a vector graphic:

•   QPicture
     Unfortunately QPicture had been forgotten, when Qt4 introduced floating point based render engines. Its API is still on integers, what make it unusable for proper scaling.

•   QSvgRenderer/QSvgGenerator
     Unfortunately QSvgRenderer hides to much information about its nodes in internal APIs, that are necessary for proper layout calculations. Also it is derived from QObject and can't be copied like QImage/QPixmap.

QwtGraphic maps all scalable drawing primitives to a QPainterPath and stores them together with the painter state changes ( pen, brush, transformation ... ) in a list of QwtPaintCommands. For being a complete QPaintDevice it also stores pixmaps or images, what is somehow against the idea of the class, because these objects can't be scaled without a loss in quality.

The main issue about scaling a QwtGraphic object are the pens used for drawing the outlines of the painter paths. While non cosmetic pens ( QPen::isCosmetic() ) are scaled with the same ratio as the path, cosmetic pens have a fixed width. A graphic might have paths with different pens - cosmetic and non-cosmetic.

QwtGraphic caches 2 different rectangles:

•   control point rectangle
     The control point rectangle is the bounding rectangle of all control point rectangles of the painter paths, or the target rectangle of the pixmaps/images.

•   bounding rectangle
     The bounding rectangle extends the control point rectangle by what is needed for rendering the outline with an unscaled pen.

Because the offset for drawing the outline depends on the shape of the painter path ( the peak of a triangle is different than the flat side ) scaling with a fixed aspect ratio always needs to be calculated from the control point rectangle.

See also
    QwtPainterCommand

Definition at line 75 of file qwt_graphic.h.

Member Typedef Documentation

  typedef QFlags<CommandType > QwtGraphic::CommandTypes
An ORed combination of CommandType values.

Definition at line 117 of file qwt_graphic.h.

  typedef QFlags<RenderHint > QwtGraphic::RenderHints
An ORed combination of RenderHint values.

Definition at line 99 of file qwt_graphic.h.

Member Enumeration Documentation

  enum QwtGraphic::CommandType
Indicator if the graphic contains a specific type of painter command

See also
    CommandTypes, commandTypes();

Enumerator

VectorData
    The graphic contains scalable vector data.

RasterData
    The graphic contains raster data ( QPixmap or QImage )

Transformation
    The graphic contains transformations beyond simple translations.

Definition at line 105 of file qwt_graphic.h.

  enum QwtGraphic::RenderHint
Hint how to render a graphic

See also
    setRenderHint(), testRenderHint()

Enumerator

RenderPensUnscaled
    When rendering a QwtGraphic a specific scaling between the controlPointRect() and the coordinates of the target rectangle is set up internally in render().

When RenderPensUnscaled is set this specific scaling is applied for the control points only, but not for the pens. All other painter transformations ( set up by application code ) are supposed to work like usual.

See also
    render();

Definition at line 82 of file qwt_graphic.h.

Constructor & Destructor Documentation

  QwtGraphic::QwtGraphic ()

Constructor. Initializes a null graphic

See also
    isNull()

Definition at line 355 of file qwt_graphic.cpp.

  QwtGraphic::QwtGraphic (const QwtGraphic & other)

Copy constructor.

Parameters
    other Source

See also
    operator=()

Definition at line 367 of file qwt_graphic.cpp.

Member Function Documentation

  QRectF QwtGraphic::boundingRect () const
The bounding rectangle is the controlPointRect() extended by the areas needed for rendering the outlines with unscaled pens.

Returns
    Bounding rectangle of the graphic

See also
    controlPointRect(), scaledBoundingRect()

Definition at line 477 of file qwt_graphic.cpp.

  const QVector< QwtPainterCommand > & QwtGraphic::commands () const

Returns
    List of recorded paint commands

See also
    setCommands()

Definition at line 1120 of file qwt_graphic.cpp.

  QwtGraphic::CommandTypes QwtGraphic::commandTypes () const

Returns
    Types of painter commands being used

Definition at line 430 of file qwt_graphic.cpp.

  QRectF QwtGraphic::controlPointRect () const
The control point rectangle is the bounding rectangle of all control points of the paths and the target rectangles of the images/pixmaps.

Returns
    Control point rectangle

See also
    boundingRect(), scaledBoundingRect()

Definition at line 493 of file qwt_graphic.cpp.

  QSizeF QwtGraphic::defaultSize () const

Default size. When a non empty size has been assigned by setDefaultSize() this size will be returned. Otherwise the default size is the size of the bounding rectangle.

The default size is used in all methods rendering the graphic, where no size is explicitly specified.

Returns
    Default size

See also
    setDefaultSize(), boundingRect()

Definition at line 574 of file qwt_graphic.cpp.

  void QwtGraphic::drawImage (const QRectF & rect, const QImage & image, const QRectF & subRect, Qt::ImageConversionFlags flags) [override], [protected], [virtual]

Store a image command in the command list.

Parameters
    rect target rectangle
    image Image to be painted
    subRect Reactangle of the pixmap to be painted
    flags Image conversion flags

See also
    QPaintEngine::drawImage()

Reimplemented from QwtNullPaintDevice.

Definition at line 1048 of file qwt_graphic.cpp.

  void QwtGraphic::drawPath (const QPainterPath & path) [override], [protected], [virtual]
Store a path command in the command list

Parameters
    path Painter path

See also
    QPaintEngine::drawPath()

Reimplemented from QwtNullPaintDevice.

Definition at line 984 of file qwt_graphic.cpp.

  void QwtGraphic::drawPixmap (const QRectF & rect, const QPixmap & pixmap, const QRectF & subRect) [override], [protected], [virtual]

Store a pixmap command in the command list.

Parameters
    rect target rectangle
    pixmap Pixmap to be painted
    subRect Reactangle of the pixmap to be painted

See also
    QPaintEngine::drawPixmap()

Reimplemented from QwtNullPaintDevice.

Definition at line 1023 of file qwt_graphic.cpp.

  qreal QwtGraphic::heightForWidth (qreal width) const
Find the height for a given width

The height is calculated using the aspect ratio of defaultSize().

Parameters
    width Width

Returns
    Calculated height

See also
    defaultSize()

Definition at line 592 of file qwt_graphic.cpp.

  bool QwtGraphic::isEmpty () const

Returns
    True, when the bounding rectangle is empty

See also
    boundingRect(), isNull()

Definition at line 422 of file qwt_graphic.cpp.

  bool QwtGraphic::isNull () const

Returns
    True, when no painter commands have been stored

See also
    isEmpty(), commands()

Definition at line 413 of file qwt_graphic.cpp.

  QwtGraphic & QwtGraphic::operator= (const QwtGraphic & other)

Assignment operator.

Parameters
    other Source

Returns
    A reference of this object

Definition at line 385 of file qwt_graphic.cpp.

  void QwtGraphic::render (QPainter * painter) const

Replay all recorded painter commands.

Parameters
    painter Qt painter

Definition at line 624 of file qwt_graphic.cpp.

  void QwtGraphic::render (QPainter * painter, const QPointF & pos, Qt::Alignment alignment = Qt::AlignTop | Qt::AlignLeft) const

Replay all recorded painter commands. The graphic is scaled to the defaultSize() and aligned to a position.

Parameters
    painter Qt painter
    pos Reference point, where to render
    alignment Flags how to align the target rectangle to pos.

Definition at line 762 of file qwt_graphic.cpp.

  void QwtGraphic::render (QPainter * painter, const QRectF & rect, Qt::AspectRatioMode aspectRatioMode = Qt::IgnoreAspectRatio) const

Replay all recorded painter commands. The graphic is scaled to fit into the given rectangle

Parameters
    painter Qt painter
    rect Rectangle for the scaled graphic
    aspectRatioMode Mode how to scale - See Qt::AspectRatioMode

Definition at line 676 of file qwt_graphic.cpp.

  void QwtGraphic::render (QPainter * painter, const QSizeF & size, Qt::AspectRatioMode aspectRatioMode = Qt::IgnoreAspectRatio) const

Replay all recorded painter commands. The graphic is scaled to fit into the rectangle of the given size starting at ( 0, 0 ).

Parameters
    painter Qt painter
    size Size for the scaled graphic
    aspectRatioMode Mode how to scale - See Qt::AspectRatioMode

Definition at line 660 of file qwt_graphic.cpp.

  QwtGraphic::RenderHints QwtGraphic::renderHints () const

Returns
    Render hints

Definition at line 464 of file qwt_graphic.cpp.

  void QwtGraphic::reset ()

Clear all stored commands.

See also
    isNull()

Definition at line 397 of file qwt_graphic.cpp.

  QRectF QwtGraphic::scaledBoundingRect (qreal sx, qreal sy) const

Calculate the target rectangle for scaling the graphic.

Parameters
    sx Horizontal scaling factor
    sy Vertical scaling factor

Note
    In case of paths that are painted with a cosmetic pen ( see QPen::isCosmetic() ) the target rectangle is different to multiplying the bounding rectangle.

Returns
    Scaled bounding rectangle

See also
    boundingRect(), controlPointRect()

Definition at line 514 of file qwt_graphic.cpp.

  void QwtGraphic::setCommands (const QVector< QwtPainterCommand > & commands)

Append paint commands.

Parameters
    commands Paint commands

See also
    commands()

Definition at line 1131 of file qwt_graphic.cpp.

  void QwtGraphic::setDefaultSize (const QSizeF & size)

Set a default size. The default size is used in all methods rendering the graphic, where no size is explicitly specified. Assigning an empty size means, that the default size will be calculated from the bounding rectangle.

The default setting is an empty size.

Parameters
    size Default size

See also
    defaultSize(), boundingRect()

Definition at line 553 of file qwt_graphic.cpp.

  void QwtGraphic::setRenderHint (RenderHint hint, bool on = true)
Toggle an render hint

Parameters
    hint Render hint
    on true/false

See also
    testRenderHint(), RenderHint

Definition at line 443 of file qwt_graphic.cpp.

  QSize QwtGraphic::sizeMetrics () const [override], [protected], [virtual]

Returns
    Ceiled defaultSize()

Implements QwtNullPaintDevice.

Definition at line 533 of file qwt_graphic.cpp.

  bool QwtGraphic::testRenderHint (RenderHint hint) const
Test a render hint

Parameters
    hint Render hint

Returns
    true/false

See also
    setRenderHint(), RenderHint

Definition at line 458 of file qwt_graphic.cpp.

  QImage QwtGraphic::toImage (const QSize & size, Qt::AspectRatioMode aspectRatioMode = Qt::IgnoreAspectRatio, qreal devicePixelRatio = 0.0) const

Convert the graphic to a QImage. All pixels of the image get initialized by 0 ( transparent ) before the graphic is scaled and rendered on it.

The format of the image is QImage::Format_ARGB32_Premultiplied.

Parameters
    size Size of the image ( will be multiplied by the devicePixelRatio )
    aspectRatioMode Aspect ratio how to scale the graphic
    devicePixelRatio Device pixel ratio for the image. If devicePixelRatio <= 0.0 the pixmap is initialized with the system default.

Returns
    The graphic as image

See also
    toPixmap(), render()

Definition at line 900 of file qwt_graphic.cpp.

  QImage QwtGraphic::toImage (qreal devicePixelRatio = 0.0) const

Convert the graphic to a QImage. All pixels of the image get initialized by 0 ( transparent ) before the graphic is scaled and rendered on it.

The format of the image is QImage::Format_ARGB32_Premultiplied.

The size of the image is the default size ( ceiled to integers ) of the graphic multiplied by the devicePixelRatio.

Parameters
    devicePixelRatio Device pixel ratio for the image. If devicePixelRatio <= 0.0 the pixmap is initialized with the system default.

Returns
    The graphic as image in default size

See also
    defaultSize(), toPixmap(), render()

Definition at line 943 of file qwt_graphic.cpp.

  QPixmap QwtGraphic::toPixmap (const QSize & size, Qt::AspectRatioMode aspectRatioMode = Qt::IgnoreAspectRatio, qreal devicePixelRatio = 0.0) const

Convert the graphic to a QPixmap. All pixels of the pixmap get initialized by Qt::transparent before the graphic is scaled and rendered on it.

Parameters
    size Size of the image
    aspectRatioMode Aspect ratio how to scale the graphic
    devicePixelRatio Device pixel ratio for the pixmap. If devicePixelRatio <= 0.0 the pixmap is initialized with the system default.

Returns
    The graphic as pixmap

See also
    toImage(), render()

Definition at line 859 of file qwt_graphic.cpp.

  QPixmap QwtGraphic::toPixmap (qreal devicePixelRatio = 0.0) const

Convert the graphic to a QPixmap. All pixels of the pixmap get initialized by Qt::transparent before the graphic is scaled and rendered on it.

The size of the pixmap is the default size ( ceiled to integers ) of the graphic.

Parameters
    devicePixelRatio Device pixel ratio for the pixmap. If devicePixelRatio <= 0.0 the pixmap is initialized with the system default.

Returns
    The graphic as pixmap in default size

See also
    defaultSize(), toImage(), render()

Definition at line 812 of file qwt_graphic.cpp.

  void QwtGraphic::updateState (const QPaintEngineState & state) [override], [protected], [virtual]

Store a state command in the command list.

Parameters
    state State to be stored

See also
    QPaintEngine::updateState()

Reimplemented from QwtNullPaintDevice.

Definition at line 1070 of file qwt_graphic.cpp.

  qreal QwtGraphic::widthForHeight (qreal height) const
Find the width for a given height

The width is calculated using the aspect ratio of defaultSize().

Parameters
    height Height

Returns
    Calculated width

See also
    defaultSize()

Definition at line 611 of file qwt_graphic.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.